///+------------------------------------------------------------------+
//|                                                 N0_NO_N0_WPR.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

#property copyright "Leonid553  http://www.tradersforum.net.ru/forum/"
#property link      "http://www.tradersforum.net.ru/"

//---- input parameters
extern int     WPR_period=5;

extern int    x1 = 92;
extern int    x2 = 53;
extern int    x3 = 97;
extern int    x4 = 95;
extern int   A1 = 93;
extern int   A2 = 119;
// StopLoss level

extern int    sl = 82;


//extern double lots = 0.1;
extern int    MagicNumber = 055;
extern int    MagicNumberLock=700;
extern int m=45;
static int prevtime = 0;
static int spread = 3;
//--- ------------
extern int   P_1=0;
extern int   P_2=7;
extern int   P_3=14;
extern int   P_4=21;
extern int    A_1=5;
extern int    A_2=10;
//--   --
#include  <b-Lots.mqh>  // 


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
     Comment(perceptron());          
  //    v        

   if(Time[0] == prevtime) // ,    
       return(0);
   prevtime = Time[0];
   
//----
   if(IsTradeAllowed()) 
     {
       spread = MarketInfo(Symbol(), MODE_SPREAD);
     } 
   else 
     {
       prevtime = Time[1];
       return(0);
     }
   int ticket = -1;
   // check for opened position
   int total = OrdersTotal();   
   for(int i = 0; i < total; i++) 
     {
   
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES); 
       // check for symbol & magic number
       if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
         {
              
           int prevticket = OrderTicket();
           // long position is opened
           if(OrderType() == OP_BUY) 
             {
      
 //*********************************************************
    //  
    //***********************************************************************                    
               // check profit 
               if(Bid > (OrderStopLoss() + (sl * 2  + spread) * Point)) 
                 { //       ,jkmit 0               
                   if(perceptron() >0) 
                     { 
                       // reverse -  
                       if (!OrderClose (prevticket, OrderLots(), Bid, 2, Blue) ) 
                       {Print("   #", GetLastError());}
                       else {
                       Lots=GetSizeLot();//   -   b-Lots
                       ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, 
                                          Ask + sl * Point, 0, "WPR_R", MagicNumber, 
                                          0, Red); 
                       }
                     
                     } 
                   else 
                     { //    -   -
                       // trailing stop
                       if(!OrderModify(OrderTicket(), OrderOpenPrice(), 
                          Bid - sl * Point, 0, 0, Blue)) 
                         {
                           Sleep(30000);
                           prevtime = Time[1];
                         }
                     }
                 }  
               // short position is opened
             } 
           else 
             {//      ...
     
 //*********************************************************
    //               
    //***********************************************************************            
               // check profit 
               if(Ask < (OrderStopLoss() - (sl * 2 + spread) * Point)) 
                 {//        0             
                   if(perceptron() < 0) 
                     { 
                       // reverse
                       if (!OrderClose (prevticket, OrderLots(), Ask, 2, Blue) ) 
                       {Print("   #", GetLastError());}
                       else {
                       Lots=GetSizeLot();//   -   b-Lots
                       ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, 
                                          Bid - sl * Point, 0, "WPR_R", MagicNumber,
                                          0, Blue);
                       }                   
                      
                     } 
                   else //     -   -
                     { 
                       // trailing stop
                       if(!OrderModify(OrderTicket(), OrderOpenPrice(), 
                          Ask + sl * Point, 0, 0, Blue)) 
                         {
                           Sleep(30000);
                           prevtime = Time[1];
                         }  
                     }
                 }  
             }
           // exit
           return(0);
         }
     }
  
   //  
   if(perceptron() < 0) 
     { 
       //long
       Lots=GetSizeLot();//  
       ticket = OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, Bid - sl * Point, 0, 
                      "WPR_R", MagicNumber, 0, Blue); 
       if(ticket < 0) 
         {
           Sleep(30000);
           prevtime = Time[1];
         }
     } 
   else 
     { 
       // short
       Lots=GetSizeLot();//  
       ticket = OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, Ask + sl * Point, 0, 
                      "WPR_R", MagicNumber, 0, Red); 
       if(ticket < 0) 
         {
           Sleep(30000);
           prevtime = Time[1];
         }
     }
//--- exit
   return(0);
  }
//+------------------------------------------------------------------+
//|  The PERCEPRRON - a perceiving and recognizing function          |
//+------------------------------------------------------------------+
double perceptron() 
  {
   double w1 = x1 - 100.0;
   double w2 = x2 - 100.0;
   double w3 = x3 - 100.0;
   double w4 = x4 - 100.0;
     double w5 = A1 - 100.0;
     double w6 = A2 - 100.0;
   double a1 = iWPR(Symbol(),  0,WPR_period,  P_1)+50; 
   double a2 = iWPR(Symbol(),  0,WPR_period,  P_2)+50;
   double a3 = iWPR(Symbol(),  0,WPR_period,  P_3)+50;
   double a4 = iWPR(Symbol(),  0,WPR_period,  P_4)+50;
     double a5 = iWPR(Symbol(), 0,WPR_period,  A_1)+50;
     double a6 = iWPR(Symbol(), 0,WPR_period,  A_2)+50;
   return (w1 * a1 + w2 * a2 + w3 * a3 + w4 * a4 + w5 * a5 + w6 * a6);
  }
    


//+------------------------------------------------------------------+}------------------+

